<template>
  <div class="px-8 page page-game" @click="closeGamePanel">
    <div class="container">
      <div class="page__header">
        <nuxt-link
          :to="$router.options.history.state.back"
          class="game__backlink"
        >
          <font-awesome-icon icon="arrow-right" class="icon-game-back" />
          {{ $t("back") }}
        </nuxt-link>
      </div>
      <div class="game" :class="{ 'hide-game-panel': isTheatreModeOn }">
        <div class="game__panel">
          <div class="game__panel-left">
            <div class="game__name">{{ gameName }}</div>
          </div>
          <div class="game__panel-right">
            <div class="game__panel-opener" @click.stop="openGamePanel">
              <font-awesome-icon icon="ellipsis" />
            </div>
            <div ref="gamePanelInnerRef" class="game__panel-inner">
              <div class="game__icon" @click="goFullScreen">
                <font-awesome-icon icon="expand" />
                <div class="tooltip">{{ $t("full_screen_mode") }}</div>
              </div>
              <div class="game__icon" @click="toggleTheatreMode">
                <font-awesome-icon icon="panorama" />
                <div class="tooltip">{{ $t("theatre_mode") }}</div>
              </div>
            </div>
          </div>
        </div>
        <div class="game__wrapper">
          <div class="game__iframe">
            <div v-loading="true"></div>
            <iframe
              v-if="gameExist && gameProviderUrl.length > 0"
              ref="gameIframeRef"
              :src="gameProviderUrl"
              frameborder="0"
              class="gameContainer"
              scrolling="yes"
              allowfullscreen="true"
              webkitallowfullscreen="true"
              mozallowfullscreen="true"
            ></iframe>
          </div>
        </div>
      </div>
      <div v-if="!gameExist" class="empty">
        <div class="empty__wrapper">
          <img
            src="http://tyche.localdev.net/desktop/black_modern_1/images/stay_tuned.png"
            alt="empty"
          />
          <h3>{{ $t("game_not_found") }}</h3>
        </div>
      </div>
    </div>
  </div>
</template>

<script setup lang="ts">
import { store } from "@/store";
import commonHelper from "@/utils/commonHelper";
import { gameStore } from "~~/store/game";

defineProps({
  gameProviderUrl: {
    type: String,
    required: false,
    default: "",
  },
});
const route = useRoute();
const gamePanelInnerRef = ref();
const gameIframeRef = ref();
const isTheatreModeOn = ref(false);
const gameId = computed(() => Number(route.params.id));

const gameExist = computed(() => {
  if (Number.isNaN(gameId.value)) return false;
  const found = gameStore.state.games.find(
    (game) => game.GameId === gameId.value
  );
  if (!found) {
    return false;
  }
  return true;
});

const { getAssetImage } = commonHelper;
const lightBackground1 = `url(${getAssetImage(
  "assets/theme/black_modern_1/fonts/empty_bg_1.svg"
)}`;
const lightBackground2 = `url(${getAssetImage(
  "assets/theme/black_modern_1/fonts/bg_page-form_1.svg"
)}`;
const darkBackground1 = `url(${getAssetImage(
  "assets/theme/black_modern_1/fonts/bg_page-form-2.svg"
)}`;
const darkBackground2 = `url(${getAssetImage(
  "assets/theme/black_modern_1/fonts/bg_page-form.svg"
)}`;

const gameName = computed(() => {
  if (Number.isNaN(gameId.value)) return "";
  const found = gameStore.state.games.find(
    (game) => game.GameId === gameId.value
  );
  if (!found) {
    return "";
  }
  return found.EnglishGameName;
});

const openGamePanel = () => {
  gamePanelInnerRef.value.classList.add("opened");
};

const closeGamePanel = () => {
  gamePanelInnerRef.value.classList.remove("opened");
};

const goFullScreen = () => {
  gameIframeRef.value.requestFullscreen();
};

const toggleTheatreMode = () => {
  isTheatreModeOn.value = !isTheatreModeOn.value;
};
</script>

<style scoped>
.page.page-game {
  padding: 16px 32px 80px;
  min-height: calc(50vh - 72px);
  color: var(--title-font-color);
}
.container {
  margin: 0 auto;
  max-width: 100%;
  width: 100%;
  -webkit-transition: padding 0.2s ease;
  transition: padding 0.2s ease;
}
@media (max-width: 640px) {
  .container {
    padding: 0 16px;
  }
}

.page__header {
  position: relative;
  display: -webkit-box;
  display: -ms-flexbox;
  display: flex;
  -webkit-box-pack: justify;
  -ms-flex-pack: justify;
  justify-content: space-between;
  -webkit-box-align: center;
  -ms-flex-align: center;
  align-items: center;
  -ms-flex-wrap: wrap;
  flex-wrap: wrap;
  margin-bottom: 40px;
}

@media (max-width: 767px) {
  .page__header {
    margin-bottom: 24px;
  }
}
.game__backlink {
  display: -webkit-box;
  display: -ms-flexbox;
  display: flex;
  -webkit-box-align: center;
  -ms-flex-align: center;
  align-items: center;
  font-size: 16px;
  line-height: 24px;
  font-weight: 600;
  text-transform: uppercase;
  color: var(--text);
  transition: all 0.5s;
}
.game__backlink .icon-game-back {
  font-size: 18px;
  margin-right: 14px;
  transform: rotate(180deg);
}
.game {
  width: 100%;
  min-height: 100%;
  display: -webkit-box;
  display: -ms-flexbox;
  display: flex;
  -webkit-box-orient: vertical;
  -webkit-box-direction: normal;
  -ms-flex-direction: column;
  flex-direction: column;
  -webkit-box-pack: justify;
  -ms-flex-pack: justify;
  justify-content: space-between;
  margin: auto;
  -webkit-box-shadow: var(--box-shadow);
  box-shadow: var(--box-shadow);
  border-radius: 16px;
  max-width: 1186px;
  -webkit-transition: width 0.2s ease-out;
  transition: width 0.2s ease-out;
}
.game.hide-game-panel {
  max-width: 100%;
  margin: 0 auto;
}
.game__panel {
  height: 72px;
  width: 100%;
  display: -webkit-box;
  display: -ms-flexbox;
  display: flex;
  -webkit-box-pack: justify;
  -ms-flex-pack: justify;
  justify-content: space-between;
  -webkit-box-align: center;
  -ms-flex-align: center;
  align-items: center;
  padding: 0 32px;
}
@media (max-width: 640px) {
  .game__panel {
    height: 48px;
  }
}
.game__panel-left {
  display: -webkit-box;
  display: -ms-flexbox;
  display: flex;
  -webkit-box-pack: start;
  -ms-flex-pack: start;
  justify-content: flex-start;
  -webkit-box-align: center;
  -ms-flex-align: center;
  align-items: center;
}
.game__name {
  font-weight: bold;
  font-size: 24px;
  line-height: 32px;
  color: var(--title-font-color);
}
@media (max-width: 640px) {
  .game__name {
    font-size: 16px;
    line-height: 20px;
  }
}

.game__panel-right {
  position: relative;
  display: -webkit-box;
  display: -ms-flexbox;
  display: flex;
}
.game__panel-opener {
  display: none;
}
@media (max-width: 640px) {
  .game__panel-opener {
    display: block;
    font-size: 24px;
  }
}
.game__panel-inner {
  display: -webkit-box;
  display: -ms-flexbox;
  display: flex;
  -webkit-box-pack: end;
  -ms-flex-pack: end;
  justify-content: flex-end;
  -webkit-box-align: center;
  -ms-flex-align: center;
  align-items: center;
}

@media (max-width: 640px) {
  .game__panel-inner {
    position: absolute;
    top: -12px;
    right: -32px;
    display: none;
    -webkit-box-orient: vertical;
    -webkit-box-direction: normal;
    -ms-flex-direction: column;
    flex-direction: column;
    -webkit-box-align: start;
    -ms-flex-align: start;
    align-items: flex-start;
    z-index: 10;
    padding: 16px;
    background: var(--background1);
    -webkit-box-shadow: 2px 2px 16px var(--box-shadow-simle);
    box-shadow: 2px 2px 16px var(--box-shadow-simle);
    border-radius: 8px;
    min-width: 170px;
    gap: 0;
  }
  .game__panel-inner.opened {
    display: -webkit-box;
    display: -ms-flexbox;
    display: flex;
  }
}

.game__icon {
  position: relative;
  display: -webkit-box;
  display: -ms-flexbox;
  display: flex;
  -webkit-box-pack: center;
  -ms-flex-pack: center;
  justify-content: center;
  -webkit-box-align: center;
  -ms-flex-align: center;
  align-items: center;
  height: 40px;
  width: 40px;
  font-size: 24px;
  -webkit-transition: color 0.2s ease-out;
  transition: color 0.2s ease-out;
  cursor: pointer;
}
@media (max-width: 640px) {
  .game__icon {
    width: 100%;
    padding-left: 1rem;
    justify-content: unset;
    border-radius: 4px;
  }
  .game__icon svg {
    width: 24px;
    height: 24px;
  }
  .game__icon:hover,
  .game__icon:focus {
    background: var(--background2);
  }
}
.game__icon:hover .tooltip,
.game__icon.active .tooltip {
  visibility: visible;
  opacity: 1;
}
.game__icon .tooltip {
  visibility: hidden;
  max-width: 160px;
  width: -webkit-max-content;
  width: -moz-max-content;
  width: max-content;
  background: var(--background-body);
  font-size: 14px;
  border-radius: 4px;
  text-align: center;
  padding: 4px 12px;
  position: absolute;
  z-index: 2;
  opacity: 0;
  -webkit-transition: opacity 0.3s;
  transition: opacity 0.3s;
  -webkit-box-shadow: var(--box-shadow-simle);
  box-shadow: var(--box-shadow-simle);
  top: calc(-100% - 18px);
  left: 50%;
  -webkit-transform: translate(-50%, 100%);
  transform: translate(-50%, 100%);
}
@media (max-width: 640px) {
  .game__icon .tooltip {
    top: auto;
    left: auto;
    -webkit-transform: none;
    transform: none;
    visibility: visible;
    opacity: 1;
    background: none;
    -webkit-box-shadow: none;
    box-shadow: none;
    position: relative;
  }
}

.game__wrapper {
  overflow: hidden;
  border-radius: 0 0 16px 16px;
}
.game__iframe {
  padding-top: 58%;
  position: relative;
  overflow: hidden;
}

.game__iframe .el-loading-parent--relative {
  position: absolute !important;
  top: 0;
  left: 0;
  display: flex;
  width: 100%;
  height: 100%;
  z-index: 1;
}
.game__iframe .el-loading-parent--relative :deep(.el-loading-spinner .path) {
  stroke: var(--accent-color);
  stroke-width: 5px;
}
.game__iframe iframe,
.game__iframe img {
  display: block;
  width: 100%;
  height: 100%;
  position: absolute;
  top: 0;
  right: 0;
  left: 0;
  bottom: 0;
  -webkit-box-sizing: border-box;
  box-sizing: border-box;
  -webkit-transform-origin: center top;
  transform-origin: center top;
  -webkit-transition: -webkit-transform 0.05s linear;
  transition: -webkit-transform 0.05s linear;
  transition: transform 0.05s linear;
  transition: transform 0.05s linear, -webkit-transform 0.05s linear;
  -webkit-backface-visibility: hidden;
  backface-visibility: hidden;
  z-index: 2;
}

.empty {
  background-image: v-bind(lightBackground1), v-bind(lightBackground2);
  background-repeat: no-repeat;
  background-position: bottom left, top right;
  background-size: contain;
}

html.dark .empty {
  background-image: v-bind(darkBackground1), v-bind(darkBackground2);
}
.empty__wrapper {
  max-width: 396px;
  margin: 0 auto;
  width: 100%;
  padding: 60px;
  background: var(--background2);
  -webkit-box-shadow: var(--box-shadow);
  box-shadow: var(--box-shadow);
  border-radius: 24px;
  text-align: center;
}
.empty h3 {
  font-size: 32px;
  line-height: 40px;
  margin-top: 10px;
  margin-bottom: 0;
  color: var(--title-font-color);
  font-weight: 700;
  user-select: none;
  font-family: "Roboto", sans-serif;
}
</style>
